package edu.travel.exception;

import edu.travel.emun.ResponseCode;

/**
 * BaseException 类。
 * <p>
 * 描述：
 *
 * @author huangwenwen
 * @date 2025/2/11
 */


public class BaseException extends RuntimeException {

    private static final long serialVersionUID = -8458116729669426482L;

    private Integer code;


    public BaseException() {
        super();
    }

    public BaseException(String message) {
        super(message);
    }

    public BaseException(Integer code, String message, Throwable cause,
                         boolean enableSuppression, boolean writableStackTrace) {
        super(message, cause, enableSuppression, writableStackTrace);
        this.code = code;
    }

    public BaseException(Integer code, String message, Throwable cause) {
        super(message, cause);
        this.code = code;
    }

    public BaseException(ResponseCode responseCode) {
        super(responseCode.getMessage());
        this.code = responseCode.getCode();
    }

    public BaseException(Integer code, String message) {
        super(message);
        this.code = code;
    }

    public BaseException(Throwable cause) {
        super(cause);
    }

    public Integer getCode() {
        return code;
    }

}
