package edu.travel.guava.cache;

import com.google.common.cache.Cache;
import com.google.common.cache.CacheBuilder;
import com.google.common.cache.CacheLoader;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cache.CacheManager;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.concurrent.TimeUnit;

@Configuration
public class GuavaCacheConfig {
    Logger logger = LoggerFactory.getLogger(GuavaCacheConfig.class);
    @Bean
    public Cache<String,Object> cache()    {
        return CacheBuilder.newBuilder()
                .initialCapacity(1000)
                .maximumSize(1000)
                .expireAfterWrite(30,TimeUnit.DAYS)
                .expireAfterAccess(30, TimeUnit.DAYS)
                .concurrencyLevel(8)
                .removalListener(notification -> {
                    logger.debug("Key " + notification.getKey() + " 被移除，原因: " + notification.getCause());
                })

                .weakKeys()

                .weakValues()
                .recordStats().build(new CacheLoader<String, Object>() {
                    @Override
                    public Object load(String s) throws Exception {
                        return null;
                    }
                });
    }



}
