package edu.travel.vo;

import com.baomidou.mybatisplus.annotation.TableField;
import edu.travel.entity.BaseEntity;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * 服务国家表
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class BaseCountryServeVo extends BaseEntity {
    /**
     * ID
     */
    private Long id;

    /**
     * 所属洲
     */
    private Long parentId;

    /**
     * 关联国家id
     */
    private Long countryId;

    /**
     * 服务费比率
     */
    private BigDecimal serviceChargeValue;

    /**
     * 结算显示方式 -0 CNY100 -1 ¥100 -2 100RMB
     */
    private Integer payViewWay;

    /**
     * 中文国家/洲名称
     */
    private String countryNameZh;

    /**
     * 英文国家/洲名称
     */
    private String countryNameEn;

    /**
     * 本地国家/洲名称
     */
    private String countryNameLocal;

    /**
     * 服务状态，默认0,-0未开通，-1开通
     */
    private Integer serveEnable;


    /**
     * 货币表id
     */
    private Long currencyId;
    /**
     * 图片url
     */
    private String imageUrl;
    /**
     * 区号
     */
    private String areaCode;

    /**
     *map
     */
    @TableField(exist = false)
    private Map<String, Object> map;
    /**
     * 子类
     */
    private List<BaseCountryServeVo> children = new ArrayList<>();
}
