package edu.travel.dto;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import edu.travel.po.PagePO;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Date;

/**
 * 库房表
 */
@Data
public class ShopWarehouseDto extends PagePO {
    /**
     * 库房表ID
     */
    private Long id;

    /**
     * 0是总仓
     */
    private Long parentId;

    /**
     * 库房名称
     */
    private String warehouseName;

    /**
     * 经度
     */
    private String longitude;

    /**
     * 维度
     */
    private String latitude;

    /**
     * 国家ID
     */
    private String countryServeId;

    /**
     * 库房详细地址
     */
    private String detailedAddress;

    /**
     * '启用禁用 0 启用 1禁用'
     */
    private Integer status;

    /**
     * 系统标识
     */
    private String project;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 创建人
     */
    private String createUserId;

    /**
     * 更新时间
     */
    private Date updateTime;

    /**
     * 更新人id
     */
    private String updateUserId;

    /**
     * 删除标记 0正常 1删除
     */
    private Integer deleteFlag;
}