package edu.travel.commodity.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import edu.travel.commodity.constant.BaseConstant;
import edu.travel.commodity.entity.ShopProduct;
import edu.travel.commodity.mapper.ShopProductMapper;
import edu.travel.commodity.service.ShopProductService;
import edu.travel.commodity.utils.PageUtil;
import edu.travel.dto.GetProductByTypeDto;
import edu.travel.dto.SearchProductDto;
import edu.travel.vo.ShopProductVo;
import org.springframework.stereotype.Service;

import java.io.IOException;

@Service
public class ShopProductServiceImpl extends ServiceImpl<ShopProductMapper, ShopProduct> implements ShopProductService {


    @Override
    public Page<ShopProductVo> getHotProduct(GetProductByTypeDto type) {
        LambdaQueryWrapper<ShopProduct> query = Wrappers.<ShopProduct>lambdaQuery()
                .eq(ShopProduct::getStatus, BaseConstant.BASIC_STATUS_NO_NUM)
                .eq(ShopProduct::getCountryId, type.getCountryId());

        if(!ObjectUtil.isEmpty(type.getType())){
            query.eq(ShopProduct::getCategoryId, type.getType());
        }
        query.orderByDesc(ShopProduct::getHeatValue);
        Page<ShopProduct> shopProductPage = baseMapper.selectPage(new Page<ShopProduct>(type.getCurrentPage(), type.getPageSize()), query);

        return PageUtil.toPageEntity(shopProductPage, ShopProductVo.class);
    }

    @Override
    public Page<ShopProductVo> searchProduct(SearchProductDto param) throws IOException {

        return null;
    }
}
