package edu.travel.commodity.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import edu.travel.commodity.entity.ShopProductSku;
import edu.travel.commodity.mapper.ShopProductSkuMapper;
import edu.travel.commodity.mapper.ShopProductSpecMapper;
import edu.travel.commodity.service.ShopProductSkuService;
import edu.travel.vo.ShopSkuSpecValueVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;
import java.util.*;
import java.util.stream.Collectors;

@Service
public class ShopProductSkuServiceImpl extends ServiceImpl<ShopProductSkuMapper, ShopProductSku> implements ShopProductSkuService {


    @Autowired
    private ShopProductSpecMapper shopProductSpecMapper;

    /**
     *  查询SKU下的规格和对应的规格值 规格 排序  规格值排序
     *  sku -> 规格 ->规格值
     * @param skuId
     * @return {@link Map }<{@link String },{@link List }<{@link ShopSkuSpecValueVo }>>
     */
    @Override
    public Map<String, List<ShopSkuSpecValueVo>> getSkuValuesById(Set<String> skuId) {
        HttpServletRequest request = ((ServletRequestAttributes) (RequestContextHolder.currentRequestAttributes())).getRequest();
        String project = request.getHeader("project");
        List<ShopSkuSpecValueVo> list = shopProductSpecMapper.getSkuValue(skuId, project);
        return  list.stream().collect(Collectors.groupingBy(ShopSkuSpecValueVo::getSkuId));
    }


}
