package edu.travel.commodity.web;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import edu.travel.commodity.entity.ShopProduct;
import edu.travel.commodity.service.ShopProductService;
import edu.travel.dto.GetProductByTypeDto;
import edu.travel.dto.SearchProductDto;
import edu.travel.resp.BaseResponse;
import edu.travel.rpc.RPCBaseResponse;
import edu.travel.vo.ShopProductVo;
import edu.travel.web.BaseController;
import org.springframework.web.bind.annotation.*;

import org.springframework.beans.factory.annotation.Autowired;

import java.io.IOException;
import java.util.List;

import static edu.travel.rpc.RPCBaseResponse.success;

/**
* 商品表(shop_product)表控制层
*
* @author xxxxx
*/
@RestController
@RequestMapping("/shop_product")
public class ShopProductController extends BaseController<ShopProduct> {
/**
* 服务对象
*/
    @Autowired
    private ShopProductService shopProductService;

    /**
     *  首页获取热门类别的热门商品
     * @param param 类型
     * @return {@link BaseResponse }<{@link List }<{@link ShopProductVo }>>
     */
    @GetMapping("/getHotProduct")
    public RPCBaseResponse<Page<ShopProductVo>> getHotProduct(GetProductByTypeDto param){
        return success(shopProductService.getHotProduct(param));
    }

    /**
     *  搜索商品
     * @param param 类型
     * @return {@link BaseResponse }<{@link List }<{@link ShopProductVo }>>
     */
    @GetMapping("/searchProduct")
    public RPCBaseResponse<Page<ShopProductVo>> searchProduct(SearchProductDto param) throws IOException {
        return success(shopProductService.searchProduct(param));
    }




}
