package edu.travel.tenant.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import edu.travel.remote.feign.mode.vo.banner.BannerVo;
import edu.travel.tenant.dto.BannerDto;
import edu.travel.tenant.entity.ShopBanner;
import edu.travel.tenant.mapper.ShopBannerMapper;
import edu.travel.tenant.service.ShopBannerService;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Service
public class ShopBannerServiceImpl extends ServiceImpl<ShopBannerMapper, ShopBanner> implements ShopBannerService {

    @Override
    public List<BannerVo> getBanner(BannerDto mode) {
       List<BannerVo> list = new ArrayList<>();
        if(ObjectUtil.isEmpty(mode.getMode()))return list;
        LambdaQueryWrapper<ShopBanner> query = Wrappers.lambdaQuery();

        query.eq(ShopBanner::getMode,mode.getMode()).eq(ShopBanner::getEnable,0).eq(ShopBanner::getCountryId,mode.getCountryId())
                .and(
                item->item.le(ShopBanner::getEndTime,new Date()).or().eq(ShopBanner::getIsDefault,1)
        );
        query.orderByDesc(ShopBanner::getSortOrder);
        List<ShopBanner> ls = list(query);
        if(!ls.isEmpty()){
            list= BeanUtil.copyToList(ls,BannerVo.class);
        }
        return list;
    }
}
