package edu.travel.tenant.web;

import edu.travel.remote.feign.mode.vo.banner.BannerVo;
import edu.travel.resp.BaseResponse;
import edu.travel.rpc.RPCBaseResponse;
import edu.travel.tenant.dto.BannerDto;
import edu.travel.tenant.entity.ShopBanner;
import edu.travel.tenant.service.ShopBannerService;
import edu.travel.web.BaseController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

import static edu.travel.rpc.RPCBaseResponse.success;

/**
* 轮播图(shop_banner)表控制层
*
* @author xxxxx
*/
@RestController
@RequestMapping("/shopBanner")
public class ShopBannerController extends BaseController<ShopBanner>{
/**
* 服务对象
*/
    @Autowired
    private ShopBannerService shopBannerService;


    /**
     *  获取轮播图
     * @param banner
     * @return {@link BaseResponse }<{@link List }<{@link BannerVo }>>
     */
    @GetMapping("/getBanner")
    public RPCBaseResponse<List<BannerVo>> getBanner(BannerDto banner){
        return success(shopBannerService.getBanner(banner));
    }



}
